// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package mwaa provides the client and types for making API
// requests to AmazonMWAA.
//
// This section contains the Amazon Managed Workflows for Apache Airflow (MWAA)
// API reference documentation. For more information, see What Is Amazon MWAA?
// (https://docs.aws.amazon.com/mwaa/latest/userguide/what-is-mwaa.html).
//
//    <p> <b>Endpoints</b> </p> <ul> <li> <p> <code>api.airflow.{region}.amazonaws.com</code>
//    - This endpoint is used for environment management.</p> <ul> <li> <p>
//    <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_CreateEnvironment.html">CreateEnvironment</a>
//    </p> </li> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_DeleteEnvironment.html">DeleteEnvironment</a>
//    </p> </li> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_GetEnvironment.html">GetEnvironment</a>
//    </p> </li> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_ListEnvironments.html">ListEnvironments</a>
//    </p> </li> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_ListTagsForResource.html">ListTagsForResource</a>
//    </p> </li> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_TagResource.html">TagResource</a>
//    </p> </li> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_UntagResource.html">UntagResource</a>
//    </p> </li> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_UpdateEnvironment.html">UpdateEnvironment</a>
//    </p> </li> </ul> </li> <li> <p> <code>env.airflow.{region}.amazonaws.com</code>
//    - This endpoint is used to operate the Airflow environment.</p> <ul> <li>
//    <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_CreateCliToken.html
//    ">CreateCliToken</a> </p> </li> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_CreateWebLoginToken.html">CreateWebLoginToken</a>
//    </p> </li> </ul> </li> <li> <p> <code>ops.airflow.{region}.amazonaws.com</code>
//    - This endpoint is used to push environment metrics that track environment
//    health.</p> <ul> <li> <p> <a href="https://docs.aws.amazon.com/mwaa/latest/API/API_PublishMetrics.html
//    ">PublishMetrics</a> </p> </li> </ul> </li> </ul> <p> <b>Regions</b> </p>
//    <p>For a list of regions that Amazon MWAA supports, see <a href="https://docs.aws.amazon.com/mwaa/latest/userguide/what-is-mwaa.html#regions-mwaa">Region
//    availability</a> in the <i>Amazon MWAA User Guide</i>.</p>
//
// See https://docs.aws.amazon.com/goto/WebAPI/mwaa-2020-07-01 for more information on this service.
//
// See mwaa package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/mwaa/
//
// Using the Client
//
// To contact AmazonMWAA with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AmazonMWAA client MWAA for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/mwaa/#New
package mwaa
