// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package organizations provides the client and types for making API
// requests to AWS Organizations.
//
// AWS Organizations is a web service that enables you to consolidate your multiple
// AWS accounts into an organization and centrally manage your accounts and
// their resources.
//
// This guide provides descriptions of the Organizations operations. For more
// information about using this service, see the AWS Organizations User Guide
// (http://docs.aws.amazon.com/organizations/latest/userguide/orgs_introduction.html).
//
// Support and feedback for AWS Organizations
//
// We welcome your feedback. Send your comments to feedback-awsorganizations@amazon.com
// (mailto:feedback-awsorganizations@amazon.com) or post your feedback and questions
// in the AWS Organizations support forum (http://forums.aws.amazon.com/forum.jspa?forumID=219).
// For more information about the AWS support forums, see Forums Help (http://forums.aws.amazon.com/help.jspa).
//
// Endpoint to call When using the AWS CLI or the AWS SDK
//
// For the current release of Organizations, specify the us-east-1 region for
// all AWS API and AWS CLI calls made from the commercial AWS Regions outside
// of China. If calling from one of the AWS Regions in China, then specify cn-northwest-1.
// You can do this in the AWS CLI by using these parameters and commands:
//
//    * Use the following parameter with each command to specify both the endpoint
//    and its region: --endpoint-url https://organizations.us-east-1.amazonaws.com
//    (from commercial AWS Regions outside of China) or --endpoint-url https://organizations.cn-northwest-1.amazonaws.com.cn
//    (from AWS Regions in China)
//
//    * Use the default endpoint, but configure your default region with this
//    command: aws configure set default.region us-east-1 (from commercial AWS
//    Regions outside of China) or aws configure set default.region cn-northwest-1
//    (from AWS Regions in China)
//
//    * Use the following parameter with each command to specify the endpoint:
//    --region us-east-1 (from commercial AWS Regions outside of China) or --region
//    cn-northwest-1 (from AWS Regions in China)
//
// Recording API Requests
//
// AWS Organizations supports AWS CloudTrail, a service that records AWS API
// calls for your AWS account and delivers log files to an Amazon S3 bucket.
// By using information collected by AWS CloudTrail, you can determine which
// requests the Organizations service received, who made the request and when,
// and so on. For more about AWS Organizations and its support for AWS CloudTrail,
// see Logging AWS Organizations Events with AWS CloudTrail (https://docs.aws.amazon.com/organizations/latest/userguide/orgs_incident-response.html#orgs_cloudtrail-integration)
// in the AWS Organizations User Guide. To learn more about AWS CloudTrail,
// including how to turn it on and find your log files, see the AWS CloudTrail
// User Guide (http://docs.aws.amazon.com/awscloudtrail/latest/userguide/what_is_cloud_trail_top_level.html).
//
// See https://docs.aws.amazon.com/goto/WebAPI/organizations-2016-11-28 for more information on this service.
//
// See organizations package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/organizations/
//
// Using the Client
//
// To contact AWS Organizations with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Organizations client Organizations for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/organizations/#New
package organizations
